#include "AndGate.h"

int AndGate::nextId=0;
float AndGate::delay=2.0;

AndGate::AndGate (float delay, Simulator* ps)
                :Gate(delay, nextId++, ps) {
}
AndGate::AndGate (Simulator* ps)
                :Gate(AndGate::delay, nextId++, ps) {
}
void AndGate::connectInput(OutSignal * p_output){
  sources.push_back(p_output);
  p_output->addDrain(this);
  inputValueChanged();
}
bool AndGate::computeOutput(){
  bool result=true;
  for (int i=0; i<sources.size(); i++)
     result = result && sources[i]->getValue(); 
  return result;
}
void AndGate::addSource(OutSignal* p_output){
  sources.push_back(p_output);
  inputValueChanged();
}
