#ifndef AND_GATE
#define AND_GATE
#include "Gate.h"
#include "Simulator.h"
#include "OutSignal.h"
using namespace std;

class AndGate: public Gate {
public:
  AndGate (float delay, Simulator * ps);
  AndGate (Simulator * ps);
  virtual void connectInput(OutSignal* p_output);
  virtual bool computeOutput();
  virtual void addSource(OutSignal * p_output);
protected:
  virtual string getSimpleName() const {
     return "AndGate";
  }
private:
  vector<OutSignal*> sources;
  static int nextId;
  static float delay;
};
#endif
