#include "Simulator.h"
#include "NandGate.h"
#include "AndGate.h"
#include "Source.h"
#include "Meter.h"
#include "Wire.h"
#include <iostream>

int main(int argc, char * argv[]) {
    Simulator sim(99999);
	
		//Source and Meter
    Source clock(argv[1], &sim);
    Source data(argv[2], &sim);
		Meter meter(argv[3]);
		
		//Nands        
		NandGate nand0(0.5f, &sim); 
		NandGate nand1(0.5f, &sim); 
		NandGate nand2(0.5f, &sim); 
		NandGate nand3(0.5f, &sim); 
		NandGate nand4(0.5f, &sim); 
		NandGate nand5(0.5f, &sim); 

		Wire w0;
    Wire w1;
    Wire w2;
		Wire w3;
		Wire qpos;
		Wire qneg;
		Wire wclock;
		Wire wdata;
		
		//Connections
		clock.connectOutput(&wclock);
		data.connectOutput(&wdata);
		
		nand0.connectOutput(&w1);
		nand1.connectOutput(&w2);
		nand2.connectOutput(&w3);
		nand3.connectOutput(&w0);
		nand4.connectOutput(&qpos);
		nand5.connectOutput(&qneg);	

		nand0.connectInput(&w0);
		nand0.connectInput(&w2); 		 

		nand1.connectInput(&w1);
		nand1.connectInput(&wclock);

		nand2.connectInput(&w2);
		nand2.connectInput(&wclock);
		nand2.connectInput(&w0);

		nand3.connectInput(&wdata);
		nand3.connectInput(&w3);

		nand4.connectInput(&w2);
		nand4.connectInput(&qneg);

		nand5.connectInput(&qpos);
		nand5.connectInput(&w3);

		meter.connectInput(&wclock);
    meter.connectInput(&wdata);
    meter.connectInput(&qpos);
    meter.connectInput(&qneg);

		/*
		//Connections
		clock.connectOutput(&nand1);
		clock.connectOutput(&nand2);

		data.connectOutput(&nand3);

		nand0.connectInput(&nand3);
		nand0.connectInput(&nand1);
		nand0.connectOutput(&nand1);

		nand1.connectInput(&nand0);
		nand1.connectInput(&clock);
		nand1.connectOutput(&nand4);

		nand2.connectInput(&nand1);
		nand2.connectInput(&clock);
		nand2.connectInput(&nand3);
		nand2.connectOutput(&nand5);

		nand3.connectInput(&data);
		nand3.connectInput(&nand2);
		nand3.connectOutput(&nand2);

		nand4.connectInput(&nand1);
		nand4.connectInput(&nand5);
		nand4.connectOutput(&nand5);

		nand5.connectInput(&nand4);
		nand5.connectInput(&nand2);
		nand5.connectOutput(&nand4);
	
		

		meter.connectInput(&clock);
    meter.connectInput(&data);
    meter.connectInput(&nand4);
    meter.connectInput(&nand5);
		*/
		
		/*
		Wire w0;
    Wire w1;
    Wire w2;

		AndGate and0(0.5f, &sim); 

		clock.connectOutput(&w0);
		data.connectOutput(&w1);

		and0.connectInput(&w0);
		and0.connectInput(&w1);
		and0.connectOutput(&w2);

    meter.connectInput(&w0);
    meter.connectInput(&w1);
    meter.connectInput(&w2);		*/
			
		//Simulation
    sim.addMeter(&meter);
    sim.simulate();

    
}
