#ifndef INVERTER
#define INVERTER
#include "Gate.h"
#include "Simulator.h"
#include "OutSignal.h"

class Inverter:public Gate {
public:
  Inverter(float delay, Simulator* ps);
  virtual bool computeOutput();
  virtual void connectInput(OutSignal * p_output);
protected:
  virtual string getSimpleName() const {
     return "Inverter";
  }
  virtual void addSource(OutSignal * p_output){
    source = p_output;
    inputValueChanged();
  }
private:
  OutSignal* source;
  static int nextId;
};
#endif