#ifndef NAND_GATE
#define NAND_GATE
#include "Gate.h"
#include "Simulator.h"
#include "OutSignal.h"
using namespace std;

class NandGate: public Gate {
public:
  NandGate (float delay, Simulator * ps);
  NandGate (Simulator * ps);
  virtual void connectInput(OutSignal* p_output);
  virtual bool computeOutput();
  virtual void addSource(OutSignal * p_output);
protected:
  virtual string getSimpleName() const {
     return "NandGate";
  }
private:
  vector<OutSignal*> sources;
  static int nextId;
  static float delay;
};
#endif
