#include "OrGate.h"

int OrGate::nextId=0;
float OrGate::delay=2.0;

OrGate::OrGate (float delay, Simulator* ps)
                :Gate(delay, nextId++, ps) {
}
OrGate::OrGate (Simulator* ps)
                :Gate(OrGate::delay, nextId++, ps) {
}
void OrGate::connectInput(OutSignal * p_output){
  sources.push_back(p_output);
  p_output->addDrain(this);
  inputValueChanged();
}
bool OrGate::computeOutput(){
  bool result=false;
  for (int i=0; i<sources.size(); i++)
     result = result || sources[i]->getValue(); 
  return result;
}
void OrGate::addSource(OutSignal* p_output){
  sources.push_back(p_output);
  inputValueChanged();
}
