#include "Simulator.h"

bool CompareEvent::operator() (const ChangeEvent* pea, const ChangeEvent* peb) const {
    return !(pea->time < peb->time);
}

Simulator::Simulator(int maxtime){
  currentTime = 0;
	n_instancias = 0;
	NMAX_instancias = 0;
	tiemposim = maxtime;
}

void Simulator::add (ChangeEvent * e){
     pq.push(e);
   }
void Simulator::addMeter(Meter* p_meter) {
  meters.push_back(p_meter);
}
void Simulator::writeHeader(){
  for (int i=0; i<meters.size(); i++)
    meters[i]->writeHeader();
    
}
void Simulator::log(float time){
  for (int i=0; i<meters.size(); i++)
    meters[i]->log(time);
}
void Simulator::simulate() {
  vector <ChangeEvent*> simultEvent; // Vector of simultaneous events
  writeHeader();
  while(!pq.empty()) {
     currentTime = pq.top()->getTime();
			if(currentTime>tiemposim)//Limitando el tiempo de simulacion
					break;     
			log(currentTime);  // log state before the change
     // get all simultaneous events
     while(true) {
			 	n_instancias=pq.top()->getnuminstancia();
				NMAX_instancias = pq.top()->getmaxinstancia();
        simultEvent.push_back(pq.top()); pq.pop();
        if (pq.empty()) break;  // done when prioriry queque is empty
        if (pq.top()->getTime()!=currentTime)  //done when event's time changes
           break;
      }
     // update output for each element realy to change
     for (int i=0; i<simultEvent.size(); i++) {
        simultEvent[i]->performUpdate();
     }
     // remove element and propagate its output update to each drain
     while (!simultEvent.empty()){
       ChangeEvent * event=simultEvent.back();
       event->propagateUpdate();
       simultEvent.pop_back();
       delete event;
     }
     log(currentTime);   // log state after the changes      
  }
	cout << "SIMULACION TERMINADA: " << endl;
	cout << "Instancias Actuales: "<< n_instancias-1 << endl;
	cout << "Numero maximo de instancias: "<< NMAX_instancias << endl;
 
}
float Simulator::getTime() const {
  return currentTime;
}
