#ifndef SIMULATOR
#define SIMULATOR
#include <queue>
#include <iostream>
#include "ChangeEvent.h"
#include "Meter.h"
using namespace std;
class ChangeEvent;

class CompareEvent {
public:
  bool operator() (const ChangeEvent* pea, const ChangeEvent* peb) const;
};

class Simulator {
private:
  // priority_queue: Primer parámetro es el tipo de los objetos de la cola ChangeEvent *
  // Segundo parámetro: es el contenedor que esta cola de prioridad usará para almacenar los datos
  // El tercer parámetro es la clase que implementa la operación de comparación.
  // en priority queue en este caso se debería generar una instancia de CompareEvent, sea ésta com,
  // y luego se usará com(pa,pb), con ap y ab dos punteros a ChangeEvent, para comparar
  // esas dos instancias. 
  priority_queue<ChangeEvent*, vector<ChangeEvent*>, CompareEvent> pq;
  vector<Meter*> meters;
  float currentTime;
	int n_instancias;
	int NMAX_instancias;
	int tiemposim;
  void log(float time);
  void writeHeader();
  
public:
  Simulator (int maxtime);
  void add (ChangeEvent* e);
  void addMeter(Meter* p_meter);
  void simulate();
  float getTime() const;
};
#endif
