#include "Source.h"
int Source::nextId=0;

Source::Source(char * inFilename, Simulator* s):id(nextId++) {
  p_sim = s;
  data.open(inFilename);
  float time;
  int val;
  data >> time;
  data >> val;
  p_sim->add(new ChangeEvent(this, val==1, time));
}
Source::~Source(){
  data.close();
}
void Source::updateOutputValue(bool val) {
  float time;
  int nextValue;
  if(val != output) 
     output = val;
  if (!data.eof()) {
     data >> time;
     data >> nextValue;
			if(time>0.01)
     p_sim->add(new ChangeEvent(this, nextValue==1, time));
  }
}
void Source::propagateOutputValue() {
  for (int i=0; i<drains.size(); i++)
    drains[i]->inputValueChanged();
}

void Source::addDrain(InSignal* p_drain){
  drains.push_back(p_drain);
}
void Source::connectOutput(InSignal* p_drain) {
  drains.push_back(p_drain);
  p_drain->addSource(this);
}

string Source::getDescription() const {
  stringstream ss;
  string s;
  ss<<"Source"<<"_#"<<id;
  getline(ss,s);
  return s;
}
